<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <script src="js/login.js"></script>
  <title>Login</title>
  <style>
      .div-image{
          background-image: url(images/signup-bg.jpg);
      }

      ::placeholder{
          text-align: center;
      }
  </style>
</head>
<body>
    <div id="register_form" >
        <div class="container-fluid div-image">
            <div class="container">
                <div class="row d-flex align-items-center min-vh-100">
                    <div class="col-sm-4 mx-auto my-0 jumbotron border border-info text-center" style="background-color: white;">
                        <div class="mb-5">
                            <h4>LOGIN ACCOUNT</h4>
                        </div>
                        <div class="form-group">
                            <input id="inp-username" placeholder="Email" type="text" class="form-control input-lg" />
                       </div>
                        <div class="form-group">
                            <input id="inp-password" type="Password" placeholder="Password" type="text" class="form-control input-lg" />
                        </div>  
                       <div class="text-center mt-4">
                           <button class="btn btn-success btn-lg btn-block" style="width: 100%;" id="btn-login">LOGIN</button>
                       </div>
                    </div>
                </div>
            </div>
        </div>  
    </div>
</body>
<script>
// $(document).ready(function(){
//     gObject = {
//         username: "",
//         password: ""
//     }

//     $("#btn-login").on("click",function(){
//         onBtnLoginClick();
//     })

//     function onBtnLoginClick() {
//         "use strict"
//         console.log("Đã nhấn nút!!!")
//         gObject.username = $("#inp-username").val();
//         gObject.password = $("#inp-password").val();
//         callApiToLogin(gObject);
//     }

//     function callApiToLogin(paramUser) {
//         "use strict"
//         $.ajax({
//                 url: "http://localhost:8080/login",
//                 type: "POST",
//                 data: JSON.stringify(paramUser),
//                 contentType: "application/json;charset=UTF-8",
//                 async: false,
//                 success: function(res) {
//                     console.log(res);
//                     alert("Token " + res);
//                     console.log("Đăng nhập thành công!");
//                 },
//                 error: function(err) {
//                     console.log(err.response);
//                     alert("Sai tài khoản hoặc mật khẩu !!!")
//                     console.log("Đăng nhập không thành công!");
//                 }
//             })
//     }


// })

$(document).ready(function() {
    //----Phần này làm sau khi đã làm trang info.js
    //Kiểm tra token nếu có token tức người dùng đã đăng nhập
    const token = getCookie("token");

    if(token) {
        window.location.href = "info.html";
    }
    //----Phần này làm sau khi đã làm trang info.js

    //Sự kiện bấm nút login
    $("#btn-login").on("click", function() {      
        var email = $("#inp-username").val().trim();
        var password = $("#inp-password").val().trim();

        if(validateForm(email, password)) {
            signinForm(email, password);
        }
    });

    function signinForm(email, password) {
        var loginUrl = "http://42.115.221.44:8080/devcamp-auth/users/signin";
        // 42.115.221.44:
        //API theo đặc tả sẽ call theo data-form chứ không phải kiểu json nên cần khai báo formdata
        var formData = new FormData();
        formData.append('email', email);
        formData.append('password', password);

        $.ajax({
            type: "POST",
            url: loginUrl,
            data: formData, 
            contentType: false,
            cache : false,
            processData: false,
            success: function(responseObject) {
                responseHandler(responseObject);
                console.log(responseObject);
            },
            error: function(xhr) {
               // Lấy error message
               var errorMessage = xhr.responseJSON.message;
               showError(errorMessage);
            }
        });
    }

    //Xử lý object trả về khi login thành công
    function responseHandler(data) {
        //Lưu token vào cookie trong 1 ngày
        setCookie("token", data.token, 1);

        window.location.href = "info.html";
    }

    //Hàm setCookie đã giới thiệu ở bài trước
    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    //Hiển thị lỗi lên form 
    function showError(message) {
        var errorElement = $("#error");

        errorElement.html(message);
        errorElement.addClass("d-block");
        errorElement.addClass("d-none");
    }

    //Validate dữ liệu từ form
    function validateForm(email, password) {
        if(!validateEmail(email)) {
            alert("Email không phù hợp");
            return false;
        };

        if(password === "") {
            alert("Password không phù hợp");
            return false;
        }

        return true;
    }

    // Hàm validate email bằng regex
    function validateEmail(email) {
        const regex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return regex.test(String(email).toLowerCase());
    }

    //Hàm get Cookie đã giới thiệu ở bài trước
    function getCookie(cname) {
        var name = cname + "=";
        var decodedCookie = decodeURIComponent(document.cookie);
        var ca = decodedCookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    }
});
</script>